#include <iostream>
#include <cstdlib>
#include <iomanip>
using namespace std;

class ZPolinomio {
	public:
		int static const MAX_DIM = 10;
		double static const E = 0.000001;
		//Attributi
		int g,p[MAX_DIM];
		double a,b;
		//Metodi
		double zPoli();
		double funz(double x);
		double zPow(double x, int n);
};

main() {
	int maxg = ZPolinomio::MAX_DIM;
	ZPolinomio poli;	
	cout << "Inserisci il grado del polinomio [max " << maxg << "]\n" ;
	cin >> poli.g;
	cout << "Inserisci i coefficienti del polinomio\n";
	for(int i=0; i <= poli.g; i++) {
		cout << "Coefficiente del termine di grado " << i << "\n";
		cin >> poli.p[i];
	}
	cout << "Inserisci il primo estremo dell'intervallo\n";
	cin >> poli.a;
	cout << "Inserisci il secondo estremo dell'intervallo\n";
	cin >> poli.b;
	cout.precision(8);
	cout << "Zero in x = " << poli.zPoli() << endl;
}

//Metodo di ricerca dello zero
double ZPolinomio::zPoli() {
	double xm = a;
	bool sem = 1;
	double xmp = 0;
	double err = 0;
	while(sem) {
		xmp = xm;
		xm = (a+b)/2;
		if(funz(xm) == 0) sem = 0; //Prima condizione di uscita
		if(xm > xmp) err = xm - xmp;
		else err = xmp - xm;
		if(err < E) sem = 0; //Seconda condizione di uscita
		if((funz(xm) * funz(a)) > 0) a = xm;
		else b = xm;
	}
	return xm;
}

//Metodo di calcolo della funzione del polinomio
double ZPolinomio::funz(double x) {
	double eval = 0;
	for(int i=0; i<=g; i++){
		eval += p[i] * zPow(x,i);
	}
	return eval;
}

//Metodo di elevamento a potenza
double ZPolinomio::zPow(double x, int n) {
	double pow = 0;
	if(n==0) pow = 1;
	else if(n==1) pow = x;
	else{
		pow = x;
		for(int i=2; i<=n; i++){
			pow *= x;
		}
	}
	return pow;
}
