#include <iostream>
#include <cstdlib>
#include <iomanip>
using namespace std;

class numeroNepero {
	public:
		//Attributi
		double maxerr;
		unsigned int maxiter;
		//Metodi
		numeroNepero();
		double calcoloNepero(unsigned int iter);
	protected:
		int calcoloFattoriale(unsigned int cont);
};

main() {
	double e;
	unsigned int iter;
	numeroNepero nep = numeroNepero();
	cout << "Inserisci il numero di iterazioni\n";
	cin >> iter;
	e = nep.calcoloNepero(iter);
	cout.precision(8);
	cout << "Il numero di Nepero e\' " << e;
}

//Costruttore
numeroNepero::numeroNepero() {
	maxerr = 0.01;
	maxiter = 1000;	
}

//Metodo di calcolo del numero e
double numeroNepero::calcoloNepero(unsigned int iter) {
	int i;
	double numeroe=0;
	if (iter>maxiter) iter=maxiter;
	for (i=0;i<iter;i++) numeroe=numeroe+(1.0/calcoloFattoriale(i));
	return numeroe;
}

//Metodo protetto di calcolo del fattoriale
int numeroNepero::calcoloFattoriale(unsigned int cont) {
	if (cont>1) return (cont*calcoloFattoriale(cont-1));
	else return 1;
}
