#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

class LCG {
	public:
		//Attruibuti
		unsigned long int s,a,c,m;
		//Metodi
		LCG();
		LCG(unsigned long int A, unsigned long int C, unsigned long int M);
		sgen(unsigned long int seed);
		unsigned long int gen();
	protected:
		//Attributi
		unsigned long int xprec;
		//Metodi
		unsigned long int int_pow(int base, int esp);
};

class piGreco {
	public:
		//Attributi
		int i,maxiter,cfr;
		double x,y,pi;
		//Metodi
		piGreco();
		double calcoloPigrecoMC();
		double calcoloPigrecoLCG();
};

main() {	
	double pimc,pilcg;
	piGreco pi = piGreco();
	pimc = pi.calcoloPigrecoMC();
	pilcg = pi.calcoloPigrecoLCG();
	cout << "Calcolo del Pi greco con il metodo MonteCarlo\n";
	cout << "Pi greco = " << pimc << endl;
	cout << "Calcolo del Pi greco con il metodo LCG\n";
	cout << "Pi greco = " << pilcg << endl;
}

//Costruttori LCG
LCG::LCG() {
	a = int_pow(7,5);
	c = 0;
	m = int_pow(2,31)-1;
}
LCG::LCG(unsigned long int A, unsigned long int C, unsigned long int M) {
	a = A;
	c = C;
	m = M;
}

//Metodo di inizializzazione
LCG::sgen(unsigned long int seed) {
	s = seed;
	xprec = 0;
}

//Metodo di generazione
unsigned long int LCG::gen(){
	unsigned long int x;
	
	if(xprec == 0) x = (a*s + c) % m;
	else x = (a*xprec + c) % m;
	xprec = x;
	
	return x;
};

//Metodo protetto di elevamento a potenza
unsigned long int LCG::int_pow(int base, int esp) {
	unsigned long int p = base;
	if(esp==0) return 1;
	else if(esp==1) return base;
	else {
		for(int e = 2; e <= esp; e++) p=p*base;
		return p;
	}
}

//Costruttore piGreco
piGreco::piGreco() {
	maxiter=100000;
	cfr=0;
}

//Metodo di calcolo del pi greco con Montecarlo
double piGreco::calcoloPigrecoMC() {
	srand(time(NULL));
	cfr=0;
	for (i=0;i<maxiter;i++) {
		x=(double)rand()/RAND_MAX;
		y=(double)rand()/RAND_MAX;
		if (x*x+y*y<1) cfr++;
	}
	pi=4*cfr/(double)maxiter;
	return pi;
}

//Metodo di calcolo del pi greco con LCG
double piGreco::calcoloPigrecoLCG() {
	unsigned long int maxval;
	LCG rangen = LCG();
	int tempo = time(NULL);
	cfr = 0;	
	maxval = rangen.m;	
	rangen.sgen(tempo);
	for(int i=1;i<=maxiter;i++)	{
		x = (double)(rangen.gen())/(double)(maxval);
		y = (double)(rangen.gen())/(double)(maxval);
		if(x*x+y*y <= 1) cfr++;
	}
	pi = 4*cfr/(double)(maxiter);
	return pi;
}
