#include <iostream>
#include <cstdlib>
#include <iomanip>
using namespace std;

class radiceQuadrata {
	public:
		//Attributi
		double maxerr;
		unsigned int maxiter;
		//Metodi
		radiceQuadrata();
		double calcoloRadiceQuadrata(double arg, unsigned int iter);
		double calcoloRadiceQuadrata(double arg, double err);
};

main() {
	double rad, arg, usererr;
	unsigned int useriter;
	char menu;
	radiceQuadrata sqrt = radiceQuadrata();
	cout << "Inserisci argomento\n";
	cin >> arg;
	cout << "Inserisci 1 per il calcolo della radice con massime iterazioni\n";
	cout << "Inserisci 2 per il calcolo della radice con massimo errore\n";
	cin >> menu;
	switch(menu) {
		case '1':
			cout << "Inserisci il numero massimo di iterazioni\n";
			cin >> useriter;
			rad=sqrt.calcoloRadiceQuadrata(arg, useriter);
			break;
		case '2': 
		    cout << "Inserisci il numero massimo di errore\n";
			cin >>usererr;
			rad=sqrt.calcoloRadiceQuadrata(arg, usererr);
			break;
	}
	cout.precision(8);
	cout << "La radice e\' " << rad;
}

//Costruttore
radiceQuadrata::radiceQuadrata() {
	maxerr=0.0001;
	maxiter=10000;
}

//Metodo di calcolo con max iterazioni
double radiceQuadrata::calcoloRadiceQuadrata(double arg, unsigned int iter) {
	int i;
	double r=arg/2;
	if (iter>maxiter) iter=maxiter;
	for (i=0; i<iter; i++) r=(r+arg/r)/2;
	return r;
}

//Metodo di calcolo con max errore
double radiceQuadrata::calcoloRadiceQuadrata(double arg, double err) {
	double r, rp, e=arg;
	int i=0;
	rp=arg/2;
	if (err>maxerr) err=maxerr;
	while (e>err && i<=maxiter)	{ 
		r=(rp+arg/rp)/2;
		e=((r-rp)/r);
		if (e<0) e=e*-1;
		rp=r;
		i++;
	}
	return r;
}
